[![GitHub version](https://badge.fury.io/gh/wxparcel%2Fwxparcel-script.svg)](https://badge.fury.io/gh/wxparcel%2Fwxparcel-script)
[![npm version](https://badge.fury.io/js/wxparcel-script.svg)](https://badge.fury.io/js/wxparcel-script)
[![Build Status](https://travis-ci.org/onepiecebase/wxparcel.svg?branch=master)](https://travis-ci.org/onepiecebase/wxparcel)

[![js-standard-style](https://img.shields.io/badge/code%20style-standard-brightgreen.svg)](http://standardjs.com)
[![GitHub](https://img.shields.io/github/license/mashape/apistatus.svg)](https://github.com/onepiecebase/wxparcel/blob/master/LICENSE)
[![LICENSE](https://img.shields.io/badge/license-Anti%20996-blue.svg)](https://github.com/996icu/996.ICU/blob/master/LICENSE)

# 小程序简易工作流

该工作流并非使用其他工作流之上进行封装, 因此可能会出现使用上的小问题, 如果有发现任何问题欢迎到 issue 进行提交

- [使用手册](https://onepiecebase.github.io/wxparcel/)

## 创建项目

```bash
$ yarn create wxparcel-app

# 安装CLI
$ npm i -g create-wxparcel-app
$ create-wxparcel-app

# 执行
$ yarn start
```

## 执行

```bash
# 运行并开启静态资源服务
$ wxparcel-script start --watch

# 使用默认配置运行 [`development`|`production`]
$ wxparcel-script start --config production

# 自定义配置运行
$ wxparcel-script start --config /path/to/wxparcel.config.js

# 配置静态资源服务域名
$ wxparcel-script start --publicPath 'https://github.com' --config production
```

## 功能简述

- 支持 编译 `scss` 或 `sass` 文件 (可配置, 默认开启)
- 支持 编译 es6 文件, 主要通过 Babel 进行编译 (可配置, 默认开启)
  - Babel 配置根据根目录下 `.babelrc` 文件来配置, 需要如何修改可以手动添加
  - 支持 `node_modules` 导入
- 支持 打包 JS 文件 (可配置, 默认开启)
- 支持 生成 SourceMap 文件 (可配置, 默认开启, js 文件仅在 `development`, `test` 模式下开启, wxss 文件则不开启)
- 支持 文件压缩 (可配置, 默认 js 文件只在 `test`, `production` 模式下开启, wxss 文件所有环境下均开启)
- 支持 资源路径替换
  - 支持 alias 路径, 例如: `~/srcDir`(资源路径), `/rootDir`(根目录路径) 与 `./relativeDir`(相对路径)
  - 支持 静态资源保存到非 CDN, 例如: `@./a.png`, `@~/a.png`, `@/a.png`
  - 支持 `.js` 文件路径替换, 例如 `require('path/to/static.ext')`
  - 支持 `.wxss` 文件路径替换, 例如 `background-image: url('path/to/static.ext')`
  - 支持 `.wxml` 文件路径替换, 例如 `<image src="path/to/static.ext" />` 路径替换
- 支持 编译环境变量替换 (默认引入)
  - 默认引入 `process.env.NODE_ENV` [`development`, `test`, `production`]
- 支持 本地开发静态服务 (可配置, 默认开发环境自动开启)
  - 若连接手机, 若手机与电脑在同一网络下即可, 不需要走代理
- 支持 自定义 `Plugins`(插件), `Loaders`(加载器) 与 `Resolvers`(解析器)
  - 插件 对应工作流不同时期的钩子进行执行, 例如, 工作流启动时清除旧生成的文件, 启动静态服务等 (可以直接在配置进行注册)
  - 加载器 是读取某些非原生支持的文件时调用的工具, 主要作用是文件转化, 例如, 将 es6 转化成 es5 (可以直接在配置进行注册)
  - 解析器 用于解析文件, 对原生文件进行二次操作, 例如, 将静态资源都替换成 CDN 地址 (自定义解析器需要通过全局 Resolver 进行注册)

## 本地开发调试工具

```
$ cd path/to/wxparcel-script
$ yarn link # 这样就可以全局通用, 若要使用全局作用于项目, 必须把本地项目的依赖删除 (建议使用)
$ # 或
$ npm link . # 这样就可以全局通用, 若要使用全局作用于项目, 必须把本地项目的依赖删除

# 若要引用到 wxparcel-script 中配置文件或内部类
$ cd path/to/project
$ yarn link wxparcel-script # 必须在 `yarn link` 之后执行 (建议使用)
$ # 或
$ npm link wxparcel-script # 必须在 `npm link .` 之后执行
```
